import { OnInit, EventEmitter, QueryList } from '@angular/core';
import { Tree } from '../../models/tree.model';
import { IconDefinition } from '@fortawesome/free-solid-svg-icons';
import { Leaf } from '../../models/leaf.model';
import { LeafClickedEvent } from '../../models/leaf-clicked-event.model';
import { ILoggingService } from '../../interfaces/ILoggingService.interface';
import { NgxBootstrapTreeviewMapper } from '../../utils/ngx-bootstrap-treeview-mapper';
import { NgxBootstrapTreeviewContextMenus } from '../../models/ngx-bootstrap-treeview-context-menus.model';
export declare class NgxBootstrapTreeviewComponent implements OnInit {
    canSelectBranch: boolean;
    contextMenus: NgxBootstrapTreeviewContextMenus;
    disableSelectedElements: boolean;
    emptyFolderLabel: string;
    isAnimationDisabled: boolean;
    isFirstLevel: boolean;
    isOpened: boolean;
    item: Object;
    items: Object[];
    loggingService: ILoggingService;
    mapper: NgxBootstrapTreeviewMapper<Object, Object>;
    preselectedItems: any[];
    tree: Tree;
    trees: Tree[];
    openedFolderIcon: IconDefinition;
    closedFolderIcon: IconDefinition;
    unselectedLeafIcon: IconDefinition;
    selectedLeafIcon: IconDefinition;
    anyChildrenSelectedIcon: IconDefinition;
    allChildrenSelectedIcon: IconDefinition;
    branchClicked: EventEmitter<Tree>;
    leafClicked: EventEmitter<LeafClickedEvent>;
    children: QueryList<NgxBootstrapTreeviewComponent>;
    5: string;
    selectedLeaves: Leaf[];
    leavesCount: number;
    isBranch: boolean;
    isLeaf: boolean;
    isRoot: boolean;
    lastContextMenuEvent: MouseEvent;
    constructor();
    ngOnInit(): void;
    onClick(): void;
    onChildLeafClicked(leafClickedEvent: LeafClickedEvent): void;
    onLeafClicked(): void;
    countLeaves(tree: Tree): number;
    select(value: any): void;
    unselect(value: any): void;
    onBranchClicked(): void;
    onChildBranchClicked(branch: Tree): void;
    onContextMenu(event: MouseEvent): void;
    onElementAdded(): boolean;
    fold(id: number | string): void;
    unfold(id: number | string): void;
    private _leafToggle;
    private _branchToggle;
    private _selectLeaf;
    private _unselectLeaf;
    private _leafIndex;
    private _leafExistsIn;
}
